/* Beasts and traps */
#include <stdlib.h>
#include <string.h>

#include "lidl.h"
#include "beasts.h"
#include "ui.h"

void beastNear( int id, int wherex, int wherey )
{
    /* This function will run if the player is close enougt
       id is the beast's id and where[xy] is where the player is */

}

void beastOn( int id, int who )
{
    /* This function will run if something is trying to standing on the beast
       if its the player then who equal -1 else id of beast */
    
}

void beastDamage( int id, int who, int damage )
{
    /* This function will be run when a beast get injured somehow
       If the attacker is the player who is equal to -1
       Else it is the value of the id of the monster */
    
}

void beastMove( int id, int wherex, int wherey )
{
    /* This function will run when a monster decide to move */
    
}

void beastInit()
{
    /* some init code might be needed */
    beast_lastId = -1; /* soo 0 becomes the first Id =) */
    /* RUN autogenerated glue here! */
}

int beastSpawn( int type, int x, int y, int z )
{
    /* used to create a monster/beast/cute rabbit */
    Beast *newBeast;
    
    newBeast = beast_add();
    
    beast_lastId++;
    
    newBeast->id = beast_lastId;
    newBeast->type = type;
    newBeast->x = x;
    newBeast->y = y;
    newBeast->z = z;
    
    /* some beast type specific returns etc here (hp, mp) */
    
    debugPrint( "created beast(%d) type %d at %d,%d,%d", 
                newBeast->id, newBeast->type, newBeast->x, newBeast->y,
                newBeast->z );
    return TRUE; /* error handling will come */
}

int beast_lastId;

/* Note: non-global code */

Beast *beast_first = NULL;
Beast *beast_last = NULL;

Beast * beast_add( void )
{
    Beast *beast;
    beast = (Beast *) malloc( sizeof( Beast ) );
    if( !beast )
	die( "malloc failed in beast_add" );
    memset( beast, 0, sizeof( Beast ) );
    if( beast_first )
    {
	beast_last->next = beast;
	beast->prev = beast_last;
	beast_last = beast;
    }
    else
	beast_first = beast_last = beast;
    
    return beast;
}

void beast_del( Beast *beast )
{
    if( beast->prev )
    {
	if( beast->next )
	{
	    beast->prev->next = beast->next;
	    beast->next->prev = beast->prev;
	}
	else
	{
	    beast->prev->next = NULL;
	    beast_last = beast->prev;
	}
    }
    else
    {
	if( beast->next )
	{
	    beast->next->prev = NULL;
	    beast_first = beast->next;
	}
	else
	    beast_first = beast_last = NULL;
    }
    
    free( beast );
}

Beast * beast_getById( int id )
{
    Beast *beast;
    
    beast = beast_first;
    
    while( !( beast->id == id || beast->next == NULL ))
    {
	debugPrint( "beast->id == %d", beast->id );
	beast = beast->next;
    }
    
    if( beast->id == id )
	return beast;
    else
	return NULL;
}

