#include <stdlib.h>
#include <string.h>

#include "lidl.h"
#include "datastructs.h"

BinTree * addBinTree(char *key, void *value);
void delBinTree(BinTree *t);

Map * addMap(void)
{
    Map *m;

    m = (Map *)malloc(sizeof(Map));
    memset(m, 0, sizeof(Map));

    return m;
}

void delMap(Map *m)
{
    if(m->tree)
	delBinTree(m->tree);
    free(m);
}

BinTree * addBinTree(char *key, void *value)
{
    BinTree *t;

    t = (BinTree *)malloc(sizeof(BinTree));
    memset(t, 0, sizeof(BinTree));

    t->key = strdup(key);
    t->value = value;

    return t;
}

/* TODO: add function-argument to free the value */
void delBinTree(BinTree *t)
{
    if(t->key)
	free(t->key);
    if(t->left)
	delBinTree(t->left);
    if(t->left)
	delBinTree(t->right);
    free(t);
}

int mapInsert(Map *m, char *key, void *value)
{
    BinTree **ot = &m->tree, *t = m->tree;
    int r;

    while(t)
    {
	r = strcmp(key, t->key);
	if(r < 0)
	{
	    ot = &t->left;
	    t = t->left;
	}
	else if(r > 0)
	{
	    ot = &t->right;
	    t = t->right;
	}
	else
	    return 1;
    }
    *ot = addBinTree(key, value);
    return 0;
}

void * mapLookup(Map *m, char *key)
{
    BinTree *t = m->tree;
    int r;

    while(t)
    {
	r = strcmp(key, t->key);
	if(r < 0)
	    t = t->left;
	else if(r > 0)
	    t = t->right;
	else
	    return t->value;
    }
    return NULL;
}
