/* game loop and glue */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "lidl.h"
#include "world.h"
#include "beasts.h"
#include "ui.h"

int gameOver;

void gameLoop()
{
    /* main loop for the game */
    uiPrint( "some help: (h)elp, (#) command line, (q)uit" );
    gameOver = FALSE;
    while( !gameOver )
    {
	gamePlayer();
	mapUpdate();
	gameBeasts();
	mapUpdate();
    }
}

void gameAskQuit()
{
    /* Called when a player wishes to quit */
    char gameQuit[2];
    uiInputString( gameQuit, sizeof( gameQuit ), "Are you sure? (y/N)" );
    if( gameQuit[0] == 'y' || gameQuit[0] == 'Y' )
	gameOver = TRUE;
}

int gameCommandLine()
{
    /* Called when a player wishes to enter a command */

    char gameCommand[20];
    int done;
    uiInputString( gameCommand, sizeof( gameCommand ), "Command" );
    done = FALSE;

    /* commands */
    if( strcmp( gameCommand, "quit" ) == 0 )
        gameAskQuit();
#ifdef DEBUG
    else if( strcmp( gameCommand, "debug" ) == 0 )
    {
        debugInteractive();
        done = TRUE;
    }
#endif
    else
        uiPrint( "'%s' command not found", gameCommand );
    
    return done;
}

void gamePlayer()
{
    /* Called when its the players turn */

    char playerChoice;
    int playerDone;
    int playerMoveOK;
    Pos playerPos, newPlayerPos;

    playerDone = 0;
    playerPos = playerGetPosition();
  
    while( !playerDone && !gameOver )
    {
	playerChoice = uiInputChar();
	debugPrint( "playerchoice = %d", playerChoice );

	if( playerChoice == 'h' )
	{
	    uiInfoBox( "Help\n\nWe hope that you are aware that this is\n"
		       "not a finished game, nor playable.\n"
		       "So remember that bugs and other evil\nbeings will come after you, and\n"
		       "currently no monsters ;)\n\n\t- blambi" );
	}
	else if( playerChoice <= uiMOVEN && playerChoice >= uiMOVESE )
	{
	    /* new move code */
	    newPlayerPos = worldGetMove( playerPos, playerChoice );
	    playerMoveOK = playerMove( newPlayerPos );

	    debugPrint( "moveok = %d", playerMoveOK );

	    if ( playerMoveOK == TRUE )
		playerDone = TRUE;
	    else
		uiPrint( "You cant go there" ); /* find out why */
	}
	else if( playerChoice == 'q' )
	    gameAskQuit();
        else if( playerChoice == '#' )
            playerDone = gameCommandLine();

	/* NOTE: don't add a else since that will just be nagging to misstakes etc... */
    }
}

void gameBeasts()
{
  /* monster ticking etc */

}
