#ifndef __LIDL_H
#define __LIDL_H

#include "datastructs.h"

#define FALSE 0
#define TRUE 1
#define VERSION "0.1.4-ng"

#define die(...) debugDie( __FILE__, __LINE__, ## __VA_ARGS__ )
#define ALIVE()  fprintf( stderr, "ALIVE: %s:%d\n", __FILE__, __LINE__ )
#define debugPrint(...) debugPrintLine( __FILE__, ## __VA_ARGS__ )

extern int gameOver;
void gameLoop();
void gameAskQuit();
extern char gameQuit[2];
void gamePlayer();
extern char gamePlayerChoice[2];
extern int gamePlayerDone;
extern int gamePlayerMoveOK;
extern char gamePlayerMoveChoice[2];
void gameBeasts();
int gameCommandLine();

extern int playerHp;
extern int playerMp;
extern int playerScore;
extern int playerMoves;
extern Pos playerPosition;
void playerInit();
int playerMove( Pos pos );
Pos playerGetPosition( void );
extern int playerFOV;
int playerGetFOV( void );
extern int playerStr;
extern int playerCon;
extern int playerDex;
extern int playerApp;
extern int playerSiz;
extern int playerHpMax;
extern int playerMpMax;
int playerGetHp( void );
int playerGetHpMax( void );
int playerGetMoves( void );

QTree *mapSeenMap;
void mapInit( void );
void mapUpdate( void );
int mapTypeAt( Pos p );

void debugInit( void );
void debugStop( void );
void debugDie( const char *file, int line, char *fmt, ... );
void debugPrintLine( const char *filename, char *fmt, ... );
void debugInteractive( void );

#endif /* __LIDL_H */
