#include <stdlib.h>
#include <string.h>

#include "lidl.h"
#include "datastructs.h"

ListNode * addListNode(List *l)
{
    ListNode *n;

    n = (ListNode *)malloc(sizeof(ListNode));
    memset(n, 0, sizeof(ListNode));

    n->list = l;

    if(!l->first)
	l->first = l->last = n;
    else
    {
	l->last->next = n;
	n->prev = l->last;
	l->last = n;
    }

    l->size++;

    return n;
}

void delListNode(ListNode *n)
{
    if(n->prev)
	n->prev->next = n->next;
    else
	n->list->first = n->next;
    if(n->next)
	n->next->prev = n->prev;
    else
	n->list->last = n->prev;

    n->list->size--;

    free(n);
}

List * addList(void)
{
    List *l;

    l = (List *)malloc(sizeof(List));
    memset(l, 0, sizeof(List));

    return l;
}

void delList(List *l)
{
    while(l->first)
	delListNode(l->first);
    free(l);
}

void swapList(List **a, List **b)
{
    List *tmp;
    tmp = *a;
    *a = *b;
    *b = tmp;
}
