%{
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "lldata.h"
#include "llparser.h"

%}

%option noyywrap
%option nounput

%x comment
STRING  \"[^\n"]+\"
ID      [A-Za-z][A-Za-z0-9]*
DIGIT   [0-9]
DICE    [0-9]+d[0-9]+

%%
"/*"                    BEGIN(comment);
<comment>[^*\n]*        /* eat anything that's not a '*' */
<comment>"*"+[^*/\n]*   /* eat up '*'s not followed by '/' */
<comment>"*"+"/"        BEGIN(INITIAL);
include                 return INCLUDE;
{DICE}                  return DICE;
{DIGIT}+                yylval.intnum = atoi(yytext); return INTEGER;
{DIGIT}*"."{DIGIT}+     yylval.floatnum = atof(yytext); return FLOAT;
[+\-^*/(){};=<>[]%,]    return (int) *yytext;
[ \t\n]+                /* ignore these */
ID                      yylval.str = strdup(yytext); return ID;
{STRING}                yylval.str = strdup(yytext); return STRING;
%%
