#include <stdlib.h>
#include <string.h>

#include "lidl.h"
#include "datastructs.h"
#include "lldata.h"

LLValue * addLLValue(unsigned char type)
{
    LLValue *v;

    v = (LLValue *)malloc(sizeof(LLValue));
    memset(v, 0, sizeof(LLValue));           /* unnecessary step? */
    v->type = type;

    return v;
}

void delLLValue(LLValue *v)
{
    ListNode *ln;

    switch(v->type)
    {
    case LLINT:
    case LLFLOAT:
    case LLSTRING:
    case LLSYMBOL:
	free(v->data);
	break;
    case LLVECTOR:
    case LLPOSITION:
	for(ln = ((List *) v->data)->first; ln; ln = ln->next)
	    delLLValue((LLValue *)ln->p);
	delList((List *)v->data);
	break;
    }
    free(v);
}

LLValue * embedInt(int val)
{
    LLValue *v = addLLValue(LLINT);
    v->data = (void *)malloc(sizeof(val));
    memcpy(v->data, &val, sizeof(val));
    return v;
}
LLValue * embedFloat(double val)
{
    LLValue *v = addLLValue(LLFLOAT);
    v->data = (void *)malloc(sizeof(val));
    memcpy(v->data, &val, sizeof(val));
    return v;
}
LLValue * embedString(char *val)
{
    LLValue *v = addLLValue(LLSTRING);
    v->data = strdup(val);
    return v;
}
LLValue * embedSymbol(char *val)
{
    LLValue *v = addLLValue(LLSYMBOL);
    v->data = strdup(val);
    return v;
}
