/* Remebers what the player have seen, and the communication with UI */
#include <stdio.h>
#include <stdlib.h>

#include "lidl.h"
#include "datastructs.h"
#include "world.h"
#include "ui.h"

typedef struct MapObject MapObject;
struct MapObject {
    Object obj;
    int type;
};

QTree *mapSeenMap; /* map of what the player have seen of the world */

/* NOTE: 
   The codes of mapSeenMap is the same as world
   BUT there is one addition code 255 (mapUNSEEN)
   which is used to hide parts ie: unseen parts */

/* FIXME:
   When monster and item code come marching
   we should add them to some kind of map to */

MapObject * mapAt( Pos p )
{
    MapObject *o = (MapObject *)getObjectAt( mapSeenMap, p );
    if( !o )
    {
	o = (MapObject *)malloc( sizeof( MapObject ) );
	o->obj.pos = p;
	o->type = mapUNSEEN;
	insertObject( &mapSeenMap, &o->obj );
    }
    return o;
}

int mapTypeAt( Pos p )
{
    MapObject *o = (MapObject *)getObjectAt( mapSeenMap, p );
    if( !o )
	return mapUNSEEN;
    return o->type;
}

void mapInit( void )
{
    /* Inits the map */

    mapSeenMap = addQRoot();
    mapUpdate(); /* to show parts that one should see */
}

void mapUpdate( void )
{
    /* draw the map */

    Pos p, tPos, cPos;
    int mapPlayerFOV;
    MapObject *mo;

    mapPlayerFOV = playerGetFOV();
    cPos = mkPos( -4, -4 );

    debugPrint( "FOV = %d", mapPlayerFOV ); 

    /* scan area (around player) */
    for( p.x = -mapPlayerFOV; p.x <= mapPlayerFOV; p.x++ )
	for( p.y = -mapPlayerFOV; p.y <= mapPlayerFOV; p.y++ )
	{
	    tPos = posAdd( p, playerGetPosition() );

	    mo = mapAt( tPos );
	    mo->type = worldCheckSpot( tPos );

	    if( !posCmp( p, mkPos( 0, 0 ) ) )
	    {
		mo = mapAt( tPos );
		mo->type = mapPLAYER;
	    }
	    debugPrint( "pos = %d,%d", p.x, p.y );
	}
    uiUpdateMap( mapSeenMap );
}
