/* player stats and related code */
#include <stdio.h>

#include "lidl.h"
#include "world.h"
#include "ui.h"

int playerHp;    /* Health */
int playerMp;    /* Magic Points (POW) */
int playerStr;   /* Strength (STR) */
int playerCon;   /* (CON) */
int playerDex;   /* Dexterity (DEX) */
int playerApp;   /* Appearance (APP) */
int playerSiz;   /* Size (SIZ) */

int playerHpMax;    /* (current) Max Health */
int playerMpMax;    /* (current) Magic Points */

int playerScore;
int playerMoves; /* Nr of moves */
Pos playerPosition;
int playerFOV;

void playerInit()
{
  /* fixes up the default values */

  playerHpMax = playerHp = 100;
  playerMpMax = playerMp = 50;
  playerFOV = 1;
  playerScore = playerMoves = 0;
  worldSpawnPlayer( &playerPosition );

#ifdef DEBUG
  debugPrint( "playerHp = %d", playerHp );
  debugPrint( "playerMp = %d", playerMp );
  debugPrint( "playerScore = %d", playerScore );
  debugPrint( "playerMoves = %d", playerMoves );
  debugPrint( "playerPosition[x] = %d", playerPosition.x );
  debugPrint( "playerPosition[y] = %d", playerPosition.y );
#endif
}

int playerMove( Pos p )
{
    /* Checks if movement is okey etc and if we move
       NOTE: Distance is not handeled here */
    int spotcode;

    spotcode = worldCheckSpot( p );

    debugPrint( "spotcode = %d", spotcode );

    if( spotcode != worldERROR && spotcode != worldWALL )
    {
	/* then move */
	playerPosition = p;
	playerMoves++;

	return TRUE;
    }
    else
	return FALSE; /* failed */
}

Pos playerGetPosition( void )
{
    return playerPosition;
}

int playerGetFOV( void )
{
  /* Returns the current Field Of View */
  
  /* TODO: add support for items that burn etc, when items are implented */
  return playerFOV;
}

int playerGetHp( void )
{
  /* Returns the current HP */
  return playerHp;
}

int playerGetHpMax( void )
{
  /* Returns the current max HP */
  return playerHpMax;
}

int playerGetMoves( void )
{
  /* Returns current number of moves/steps */
  return playerMoves;
}
